package com.liquidnet.service.goblin.service.impl.inner;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.read.listener.PageReadListener;
import com.liquidnet.commons.lang.util.IDGenerator;
import com.liquidnet.service.base.ResponseDto;
import com.liquidnet.service.goblin.dto.vo.ArDataVo;
import com.liquidnet.service.goblin.dto.vo.GoblinGoodsInfoVo;
import com.liquidnet.service.goblin.dto.vo.TempCouponVo;
import com.liquidnet.service.goblin.service.GoblinFrontService;
import com.liquidnet.service.goblin.service.manage.IGoblinInnerService;
import com.liquidnet.service.goblin.util.GoblinRedisUtils;
import com.liquidnet.service.goblin.util.ObjectUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Slf4j
@Service
public class GoblinInnerServiceImpl implements IGoblinInnerService {

    @Autowired
    GoblinRedisUtils redisUtils;
    @Autowired
    GoblinFrontService goblinFrontService;

    @Override
    public ResponseDto<String> insertCoupon(MultipartFile file, String performanceId) {
        try {
            EasyExcel.read(file.getInputStream(), TempCouponVo.class, new PageReadListener<TempCouponVo>(dataList -> {
                redisUtils.delMarketTempCoupon(performanceId);
                for (TempCouponVo data : dataList) {
                    if (data.getSpuId() == null) {
                        continue;
                    }
                    List<String> spuList = Arrays.asList(data.getSpuId().split(","));
                    data.setSpuIdList(spuList);
                    data.setUcouponId(IDGenerator.nextTimeId2());
                    redisUtils.addMarketTempCoupon(performanceId, data.getUcouponId());
                    redisUtils.setTempCoupon(data.getUcouponId(), data);
                }
            })).sheet().doRead();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ResponseDto.success("完成");
    }

    @Override
    public ResponseDto<ArDataVo> getArData(String tag, String performanceId) {
        ArDataVo vo = ArDataVo.getNew();
        //券
        ArrayList<TempCouponVo> tempCouponVos = ObjectUtil.getTempCouponVo();
        List<String> ucouponIds = redisUtils.getMarketTempCoupon(performanceId);
        for (String ucouponId : ucouponIds) {
            TempCouponVo tempCouponVo = redisUtils.getTempCoupon(ucouponId);
            tempCouponVos.add(tempCouponVo);
        }
        vo.setTempCouponVos(tempCouponVos);
        //商品
        List<GoblinGoodsInfoVo> goodsInfoVos = goblinFrontService.getGoodByMusicTagP(tag, performanceId);
        vo.setGoodsInfoVos(goodsInfoVos);
        return ResponseDto.success(vo);
    }
}
